* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
* $Id: _move.s,v 1.0 1995/02/13 20:50:53 nenetto Exp $
*
		.xdef	_move


		.offset	0
x:		.ds.w	1		*  xW
y:		.ds.w	1		*  yW
x0:		.ds.w	1		* xW *64
y0:		.ds.w	1		* yW *64
lx0:		.ds.w	1		* x
lx1:		.ds.w	1		* x
ly0:		.ds.w	1		* y
ly1:		.ds.w	1		* y
vx:		.ds.w	1		* xx
vy:		.ds.w	1		* yx
ax:		.ds.w	1		* xx
ay:		.ds.w	1		* yx
rx:		.ds.w	1		* xˌW
ry:		.ds.w	1		* yˌW
ux:		.ds.w	1		* xCW
uy:		.ds.w	1		* yCW
xy:		.ds.w	1		* xyW
z:		.ds.w	1		* 0xJE^
Frx:		.ds.b	1		* x˕ԂtO
Fry:		.ds.b	1		* y˕ԂtO
		.text


* ------------------------------------------------------------
*	2D^
*
*	input	a0(.l) : parameter table address
*
_move:
		movem.l	d0-d6/a0-a6,-(sp)
		
		move.w	x0(a0),d2		* x*64
		move.w	vx(a0),d3		* v
		tst.b	Frx(a0)			* Oɒ˕Ԃ ?
		bne	1f

		add.w	ax(a0),d3		* v=v+a
		muls	ux(a0),d3		* v=u*v
		asr.l	#8,d3
		add.w	d3,d2			* x=x+v
		
		cmp.w	lx0(a0),d2		* ˕Ԃ ?
		blt	2f
		cmp.w	lx1(a0),d2		* ˕Ԃ ?
		bgt	3f

	1:	move.w	d2,x0(a0)		* 
		asr.w	#6,d2
		move.w	d2,x(a0)		* loc. x
		move.w	d3,vx(a0)		* 
		sf	Frx(a0)
	bra	5f

	2:	neg.w	d3			* x]
		muls	rx(a0),d3		* v=r*v
		asr.l	#8,d3
		add.w	d3,d2
		cmp.w	lx0(a0),d2
		bge	@f
		move.w	lx0(a0),d2
	@@:	move.w	lx0(a0),d0
		asr.w	#6,d0
		move.w	d0,x(a0)
	bra	4f

	3:	neg.w	d3			* x]
		muls	rx(a0),d3
		asr.l	#8,d3
		add.w	d3,d2
		cmp.w	lx1(a0),d2
		ble	@f
		move.w	lx1(a0),d2
	@@:	move.w	lx1(a0),d0
		asr.w	#6,d0
		move.w	d0,x(a0)

	4:	st	Frx(a0)
		move.w	d2,x0(a0)		* 
		move.w	d3,vx(a0)		* 
		muls	xy(a0),d3		* vy=xy*vx
		asr.l	#8,d3
		add.w	d3,vy(a0)		* 
	5:	

	
		move.w	y0(a0),d2		* y*64
		move.w	vy(a0),d3		* v
		tst.b	Fry(a0)			* Oɒ˕Ԃ ?
		bne	1f

		add.w	ay(a0),d3
		muls	uy(a0),d3
		asr.l	#8,d3
		add.w	d3,d2
		
		cmp.w	ly0(a0),d2		* ˕Ԃ ?
		blt	2f
		cmp.w	ly1(a0),d2		* ˕Ԃ ?
		bgt	3f

	1:	move.w	d2,y0(a0)		* 
		asr.w	#6,d2
		move.w	d2,y(a0)		* loc. y
		move.w	d3,vy(a0)		* 
		sf	Fry(a0)
	bra	5f

	2:	neg.w	d3			* x]
		muls	ry(a0),d3
		asr.l	#8,d3
		add.w	d3,d2
		cmp.w	ly0(a0),d2
		bge	@f
		move.w	ly0(a0),d2
	@@:	move.w	ly0(a0),d0
		asr.w	#6,d0
		move.w	d0,y(a0)
	bra	4f

	3:	neg.w	d3			* x]
		muls	ry(a0),d3
		asr.l	#8,d3
		add.w	d3,d2
		cmp.w	ly1(a0),d2
		ble	@f
		move.w	ly1(a0),d2
	@@:	move.w	ly1(a0),d0
		asr.w	#6,d0
		move.w	d0,y(a0)

	4:	st	Fry(a0)
		move.w	d2,y0(a0)		* 
		move.w	d3,vy(a0)		* 
		muls	xy(a0),d3		* vx=xy*vy
		asr.l	#8,d3
		add.w	d3,vx(a0)		* 
	5:	

		moveq	#0,d7
		tst.l	vx(a0)
		bne	1f
		sub.w	#1,z(a0)
	bra	2f
	1:	move.w	#4,z(a0)
	2:	move.w	z(a0),d7
		
		movem.l	(sp)+,d0-d6/a0-a6
		rts
* ------------------------------------------------------------


		.end
